#
# Cookbook Name:: Venafi TPP
# Recipe:: default
#
# Copyright 2015, Venafi
#
# All rights reserved - Do Not Redistribute
#

require "base64"
#include_recipe 'webhooks::tpp_authenticate'

require "mixlib/log/formatter"

#############################################################################################################################



webhooks_request "certificates_request" do
  uri lazy {"#{node["tpp"]["server"]}/vedsdk/certificates/request?apikey=#{node["tpp"]["apikey"]}" }
  #uri lazy {"127.0.0.1/vedsdk/certificates/request?apikey=#{node["tpp"]["apikey"]}"}
  #uri_port 5000
  ssl_validation false
  use_ssl true
  post_json true
  follow_redirect true
  post_data (
                {'PolicyDN' => node["tpp"]["policy_dn"],
                 'CADN' => node["tpp"]["cadn"],
                 'ObjectName' => node["tpp"]["object_name"],
                 "Subject" => node["tpp"]["object_name"],
                 'CASpecificAttributes' => [{
                                                'Name' => 'Validity Period',
                                                'Value' => '365'
                                            }]}
            )
  header_data (
                  { 'content-type' => 'application/json' }
              )
  expected_response_codes [ 200, 201 ]
  action :nothing
end

ruby_block "Request Certificate" do
  block do
    resources(:webhooks_request => "certificates_request").run_action(:post)
    jsonData = JSON.parse(node["webhooks"]["post_response"])
    jsonData.each do | k, v |

      if k == 'CertificateDN'
        node.set["tpp"]["certificate_dn"] = v
        Chef::Log.info "Request for new certificate was successful, certificate DN is: #{node["tpp"]["certificate_dn"]}"
      end
    end
    Chef::Log.info "==============================================================================="
    Chef::Log.info "\n\nTPP response message: " + node["webhooks"]["response_message"]
    Chef::Log.info "\n\nTPP response code: " + node["webhooks"]["response_code"]
    Chef::Log.info "\n\nTPP response: " + node["webhooks"]["post_response"]
    Chef::Log.info "==============================================================================="

  end
  action :run
end
