#
# Cookbook Name:: Venafi TPP
# Recipe:: default
#
# Copyright 2015, Venafi
#
# All rights reserved - Do Not Redistribute
#

require "base64"
#include_recipe 'webhooks::tpp_authenticate'

#############################################################################################################################



webhooks_request "certificates_revoke" do
  uri lazy {"#{node["tpp"]["server"]}/vedsdk/certificates/revoke?apikey=#{node["tpp"]["apikey"]}" }
  ssl_validation false
  use_ssl true
  post_json true
  follow_redirect true
  post_data (
                {'CertificateDN' => node["tpp"]["certificate_dn"],
                 'Reason' => node["tpp"]["revoke_reason"],
                 'Comments' => node["tpp"]["revoke_comment"],
                 }
            )
  header_data (
                  { 'content-type' => 'application/json' }
              )
  expected_response_codes [ 200, 201, 400 ]
  action :nothing
end

ruby_block "Revoke Certificate" do
  block do
    resources(:ruby_block => "set_auth_key").run_action(:run)
    resources(:webhooks_request => "certificates_revoke").run_action(:post)

    Chef::Log.info "\n\nTPP response: " + node["webhooks"]["post_response"]
  end
  action :run
end





