#
# Cookbook Name:: Venafi TPP
# Recipe:: default
#
# Copyright 2015, Venafi
#
# All rights reserved - Do Not Redistribute
#

require "base64"


#############################################################################################################################

webhooks_request "vedsdk_authorize" do
  uri "#{node["tpp"]["server"]}/vedsdk/authorize/"
  ssl_validation false
  use_ssl true
  post_json true
  post_data (
                { 'Username' => node["tpp"]["username"], 'Password' => node["tpp"]["password"]}
            )
  header_data (
                  { 'content-type' => 'application/json'}
              )
  expected_response_codes [ 200, 201, 400 ]
  action :nothing
end


ruby_block "set_auth_key" do
  block do
    resources(:webhooks_request => "vedsdk_authorize").run_action(:post)
    jsonData = JSON.parse(node["webhooks"]["post_response"])
    jsonData.each do | k, v |

      if k == 'APIKey'
        node.set["tpp"]["apikey"] = v
        Chef::Log.info "API Key: " + node["tpp"]["apikey"]
      end
    end
  end
  action :run
end
